net.minecraft.network

## Class PacketBuffer

- java.lang.Object
- - io.netty.buffer.ByteBuf
  - - net.minecraft.network.PacketBuffer

- All Implemented Interfaces:
    io.netty.util.ReferenceCounted, java.lang.Comparable<io.netty.buffer.ByteBuf>

      public class PacketBuffer
      extends io.netty.buffer.ByteBuf

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PacketBuffer(io.netty.buffer.ByteBuf p_i45154_1_)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `io.netty.buffer.ByteBufAllocator` | `alloc()`
    `byte[]` | `array()`
    `int` | `arrayOffset()`
    `int` | `bytesBefore(byte p_bytesBefore_1_)`
    `int` | `bytesBefore(int p_bytesBefore_1_, byte p_bytesBefore_2_)`
    `int` | `bytesBefore(int p_bytesBefore_1_, int p_bytesBefore_2_, byte p_bytesBefore_3_)`
    `int` | `capacity()`
    `io.netty.buffer.ByteBuf` | `capacity(int p_capacity_1_)`
    `io.netty.buffer.ByteBuf` | `clear()`
    `int` | `compareTo(io.netty.buffer.ByteBuf par1Obj)`
    `io.netty.buffer.ByteBuf` | `copy()`
    `io.netty.buffer.ByteBuf` | `copy(int p_copy_1_, int p_copy_2_)`
    `io.netty.buffer.ByteBuf` | `discardReadBytes()`
    `io.netty.buffer.ByteBuf` | `discardSomeReadBytes()`
    `io.netty.buffer.ByteBuf` | `duplicate()`
    `io.netty.buffer.ByteBuf` | `ensureWritable(int p_ensureWritable_1_)`
    `int` | `ensureWritable(int p_ensureWritable_1_, boolean p_ensureWritable_2_)`
    `boolean` | `equals(java.lang.Object par1Obj)`
    `int` | `forEachByte(io.netty.buffer.ByteBufProcessor p_forEachByte_1_)`
    `int` | `forEachByte(int p_forEachByte_1_, int p_forEachByte_2_, io.netty.buffer.ByteBufProcessor p_forEachByte_3_)`
    `int` | `forEachByteDesc(io.netty.buffer.ByteBufProcessor p_forEachByteDesc_1_)`
    `int` | `forEachByteDesc(int p_forEachByteDesc_1_, int p_forEachByteDesc_2_, io.netty.buffer.ByteBufProcessor p_forEachByteDesc_3_)`
    `boolean` | `getBoolean(int p_getBoolean_1_)`
    `byte` | `getByte(int p_getByte_1_)`
    `io.netty.buffer.ByteBuf` | `getBytes(int p_getBytes_1_, byte[] p_getBytes_2_)`
    `io.netty.buffer.ByteBuf` | `getBytes(int p_getBytes_1_, byte[] p_getBytes_2_, int p_getBytes_3_, int p_getBytes_4_)`
    `io.netty.buffer.ByteBuf` | `getBytes(int p_getBytes_1_, io.netty.buffer.ByteBuf p_getBytes_2_)`
    `io.netty.buffer.ByteBuf` | `getBytes(int p_getBytes_1_, java.nio.ByteBuffer p_getBytes_2_)`
    `io.netty.buffer.ByteBuf` | `getBytes(int p_getBytes_1_, io.netty.buffer.ByteBuf p_getBytes_2_, int p_getBytes_3_)`
    `io.netty.buffer.ByteBuf` | `getBytes(int p_getBytes_1_, io.netty.buffer.ByteBuf p_getBytes_2_, int p_getBytes_3_, int p_getBytes_4_)`
    `int` | `getBytes(int p_getBytes_1_, java.nio.channels.GatheringByteChannel p_getBytes_2_, int p_getBytes_3_)`
    `io.netty.buffer.ByteBuf` | `getBytes(int p_getBytes_1_, java.io.OutputStream p_getBytes_2_, int p_getBytes_3_)`
    `char` | `getChar(int p_getChar_1_)`
    `double` | `getDouble(int p_getDouble_1_)`
    `float` | `getFloat(int p_getFloat_1_)`
    `int` | `getInt(int p_getInt_1_)`
    `long` | `getLong(int p_getLong_1_)`
    `int` | `getMedium(int p_getMedium_1_)`
    `short` | `getShort(int p_getShort_1_)`
    `short` | `getUnsignedByte(int p_getUnsignedByte_1_)`
    `long` | `getUnsignedInt(int p_getUnsignedInt_1_)`
    `int` | `getUnsignedMedium(int p_getUnsignedMedium_1_)`
    `int` | `getUnsignedShort(int p_getUnsignedShort_1_)`
    `static int` | `getVarIntSize(int p_150790_0_)`
    `boolean` | `hasArray()`
    `int` | `hashCode()`
    `boolean` | `hasMemoryAddress()`
    `int` | `indexOf(int p_indexOf_1_, int p_indexOf_2_, byte p_indexOf_3_)`
    `java.nio.ByteBuffer` | `internalNioBuffer(int p_internalNioBuffer_1_, int p_internalNioBuffer_2_)`
    `boolean` | `isDirect()`
    `boolean` | `isReadable()`
    `boolean` | `isReadable(int p_isReadable_1_)`
    `boolean` | `isWritable()`
    `boolean` | `isWritable(int p_isWritable_1_)`
    `io.netty.buffer.ByteBuf` | `markReaderIndex()`
    `io.netty.buffer.ByteBuf` | `markWriterIndex()`
    `int` | `maxCapacity()`
    `int` | `maxWritableBytes()`
    `long` | `memoryAddress()`
    `java.nio.ByteBuffer` | `nioBuffer()`
    `java.nio.ByteBuffer` | `nioBuffer(int p_nioBuffer_1_, int p_nioBuffer_2_)`
    `int` | `nioBufferCount()`
    `java.nio.ByteBuffer[]` | `nioBuffers()`
    `java.nio.ByteBuffer[]` | `nioBuffers(int p_nioBuffers_1_, int p_nioBuffers_2_)`
    `java.nio.ByteOrder` | `order()`
    `io.netty.buffer.ByteBuf` | `order(java.nio.ByteOrder p_order_1_)`
    `int` | `readableBytes()`
    `boolean` | `readBoolean()`
    `byte` | `readByte()`
    `io.netty.buffer.ByteBuf` | `readBytes(byte[] p_readBytes_1_)`
    `io.netty.buffer.ByteBuf` | `readBytes(byte[] p_readBytes_1_, int p_readBytes_2_, int p_readBytes_3_)`
    `io.netty.buffer.ByteBuf` | `readBytes(io.netty.buffer.ByteBuf p_readBytes_1_)`
    `io.netty.buffer.ByteBuf` | `readBytes(java.nio.ByteBuffer p_readBytes_1_)`
    `io.netty.buffer.ByteBuf` | `readBytes(io.netty.buffer.ByteBuf p_readBytes_1_, int p_readBytes_2_)`
    `io.netty.buffer.ByteBuf` | `readBytes(io.netty.buffer.ByteBuf p_readBytes_1_, int p_readBytes_2_, int p_readBytes_3_)`
    `int` | `readBytes(java.nio.channels.GatheringByteChannel p_readBytes_1_, int p_readBytes_2_)`
    `io.netty.buffer.ByteBuf` | `readBytes(int p_readBytes_1_)`
    `io.netty.buffer.ByteBuf` | `readBytes(java.io.OutputStream p_readBytes_1_, int p_readBytes_2_)`
    `char` | `readChar()`
    `double` | `readDouble()`
    `int` | `readerIndex()`
    `io.netty.buffer.ByteBuf` | `readerIndex(int p_readerIndex_1_)`
    `float` | `readFloat()`
    `int` | `readInt()`
    `ItemStack` | `readItemStackFromBuffer()`
    `long` | `readLong()`
    `int` | `readMedium()`
    `NBTTagCompound` | `readNBTTagCompoundFromBuffer()`
    `short` | `readShort()`
    `io.netty.buffer.ByteBuf` | `readSlice(int p_readSlice_1_)`
    `java.lang.String` | `readStringFromBuffer(int p_150789_1_)`
    `short` | `readUnsignedByte()`
    `long` | `readUnsignedInt()`
    `int` | `readUnsignedMedium()`
    `int` | `readUnsignedShort()`
    `int` | `readVarIntFromBuffer()`
    `int` | `refCnt()`
    `boolean` | `release()`
    `boolean` | `release(int p_release_1_)`
    `io.netty.buffer.ByteBuf` | `resetReaderIndex()`
    `io.netty.buffer.ByteBuf` | `resetWriterIndex()`
    `io.netty.buffer.ByteBuf` | `retain()`
    `io.netty.buffer.ByteBuf` | `retain(int p_retain_1_)`
    `io.netty.buffer.ByteBuf` | `setBoolean(int p_setBoolean_1_, boolean p_setBoolean_2_)`
    `io.netty.buffer.ByteBuf` | `setByte(int p_setByte_1_, int p_setByte_2_)`
    `io.netty.buffer.ByteBuf` | `setBytes(int p_setBytes_1_, byte[] p_setBytes_2_)`
    `io.netty.buffer.ByteBuf` | `setBytes(int p_setBytes_1_, byte[] p_setBytes_2_, int p_setBytes_3_, int p_setBytes_4_)`
    `io.netty.buffer.ByteBuf` | `setBytes(int p_setBytes_1_, io.netty.buffer.ByteBuf p_setBytes_2_)`
    `io.netty.buffer.ByteBuf` | `setBytes(int p_setBytes_1_, java.nio.ByteBuffer p_setBytes_2_)`
    `io.netty.buffer.ByteBuf` | `setBytes(int p_setBytes_1_, io.netty.buffer.ByteBuf p_setBytes_2_, int p_setBytes_3_)`
    `io.netty.buffer.ByteBuf` | `setBytes(int p_setBytes_1_, io.netty.buffer.ByteBuf p_setBytes_2_, int p_setBytes_3_, int p_setBytes_4_)`
    `int` | `setBytes(int p_setBytes_1_, java.io.InputStream p_setBytes_2_, int p_setBytes_3_)`
    `int` | `setBytes(int p_setBytes_1_, java.nio.channels.ScatteringByteChannel p_setBytes_2_, int p_setBytes_3_)`
    `io.netty.buffer.ByteBuf` | `setChar(int p_setChar_1_, int p_setChar_2_)`
    `io.netty.buffer.ByteBuf` | `setDouble(int p_setDouble_1_, double p_setDouble_2_)`
    `io.netty.buffer.ByteBuf` | `setFloat(int p_setFloat_1_, float p_setFloat_2_)`
    `io.netty.buffer.ByteBuf` | `setIndex(int p_setIndex_1_, int p_setIndex_2_)`
    `io.netty.buffer.ByteBuf` | `setInt(int p_setInt_1_, int p_setInt_2_)`
    `io.netty.buffer.ByteBuf` | `setLong(int p_setLong_1_, long p_setLong_2_)`
    `io.netty.buffer.ByteBuf` | `setMedium(int p_setMedium_1_, int p_setMedium_2_)`
    `io.netty.buffer.ByteBuf` | `setShort(int p_setShort_1_, int p_setShort_2_)`
    `io.netty.buffer.ByteBuf` | `setZero(int p_setZero_1_, int p_setZero_2_)`
    `io.netty.buffer.ByteBuf` | `skipBytes(int p_skipBytes_1_)`
    `io.netty.buffer.ByteBuf` | `slice()`
    `io.netty.buffer.ByteBuf` | `slice(int p_slice_1_, int p_slice_2_)`
    `java.lang.String` | `toString()`
    `java.lang.String` | `toString(java.nio.charset.Charset p_toString_1_)`
    `java.lang.String` | `toString(int p_toString_1_, int p_toString_2_, java.nio.charset.Charset p_toString_3_)`
    `io.netty.buffer.ByteBuf` | `unwrap()`
    `int` | `writableBytes()`
    `io.netty.buffer.ByteBuf` | `writeBoolean(boolean p_writeBoolean_1_)`
    `io.netty.buffer.ByteBuf` | `writeByte(int p_writeByte_1_)`
    `io.netty.buffer.ByteBuf` | `writeBytes(byte[] p_writeBytes_1_)`
    `io.netty.buffer.ByteBuf` | `writeBytes(byte[] p_writeBytes_1_, int p_writeBytes_2_, int p_writeBytes_3_)`
    `io.netty.buffer.ByteBuf` | `writeBytes(io.netty.buffer.ByteBuf p_writeBytes_1_)`
    `io.netty.buffer.ByteBuf` | `writeBytes(java.nio.ByteBuffer p_writeBytes_1_)`
    `io.netty.buffer.ByteBuf` | `writeBytes(io.netty.buffer.ByteBuf p_writeBytes_1_, int p_writeBytes_2_)`
    `io.netty.buffer.ByteBuf` | `writeBytes(io.netty.buffer.ByteBuf p_writeBytes_1_, int p_writeBytes_2_, int p_writeBytes_3_)`
    `int` | `writeBytes(java.io.InputStream p_writeBytes_1_, int p_writeBytes_2_)`
    `int` | `writeBytes(java.nio.channels.ScatteringByteChannel p_writeBytes_1_, int p_writeBytes_2_)`
    `io.netty.buffer.ByteBuf` | `writeChar(int p_writeChar_1_)`
    `io.netty.buffer.ByteBuf` | `writeDouble(double p_writeDouble_1_)`
    `io.netty.buffer.ByteBuf` | `writeFloat(float p_writeFloat_1_)`
    `io.netty.buffer.ByteBuf` | `writeInt(int p_writeInt_1_)`
    `void` | `writeItemStackToBuffer(ItemStack p_150788_1_)`
    `io.netty.buffer.ByteBuf` | `writeLong(long p_writeLong_1_)`
    `io.netty.buffer.ByteBuf` | `writeMedium(int p_writeMedium_1_)`
    `void` | `writeNBTTagCompoundToBuffer(NBTTagCompound p_150786_1_)`
    `int` | `writerIndex()`
    `io.netty.buffer.ByteBuf` | `writerIndex(int p_writerIndex_1_)`
    `io.netty.buffer.ByteBuf` | `writeShort(int p_writeShort_1_)`
    `void` | `writeStringToBuffer(java.lang.String p_150785_1_)`
    `void` | `writeVarIntToBuffer(int p_150787_1_)`
    `io.netty.buffer.ByteBuf` | `writeZero(int p_writeZero_1_)`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### PacketBuffer

          public PacketBuffer(io.netty.buffer.ByteBuf p_i45154_1_)

  - ### Method Detail

    - #### getVarIntSize

          public static int getVarIntSize(int p_150790_0_)

    - #### readVarIntFromBuffer

          public int readVarIntFromBuffer()

    - #### writeVarIntToBuffer

          public void writeVarIntToBuffer(int p_150787_1_)

    - #### writeNBTTagCompoundToBuffer

          public void writeNBTTagCompoundToBuffer(NBTTagCompound p_150786_1_)
                                           throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readNBTTagCompoundFromBuffer

          public NBTTagCompound readNBTTagCompoundFromBuffer()
                                                      throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeItemStackToBuffer

          public void writeItemStackToBuffer(ItemStack p_150788_1_)
                                      throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readItemStackFromBuffer

          public ItemStack readItemStackFromBuffer()
                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### readStringFromBuffer

          public java.lang.String readStringFromBuffer(int p_150789_1_)
                                                throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeStringToBuffer

          public void writeStringToBuffer(java.lang.String p_150785_1_)
                                   throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### capacity

          public int capacity()

      Specified by:
        `capacity` in class `io.netty.buffer.ByteBuf`

    - #### capacity

          public io.netty.buffer.ByteBuf capacity(int p_capacity_1_)

      Specified by:
        `capacity` in class `io.netty.buffer.ByteBuf`

    - #### maxCapacity

          public int maxCapacity()

      Specified by:
        `maxCapacity` in class `io.netty.buffer.ByteBuf`

    - #### alloc

          public io.netty.buffer.ByteBufAllocator alloc()

      Specified by:
        `alloc` in class `io.netty.buffer.ByteBuf`

    - #### order

          public java.nio.ByteOrder order()

      Specified by:
        `order` in class `io.netty.buffer.ByteBuf`

    - #### order

          public io.netty.buffer.ByteBuf order(java.nio.ByteOrder p_order_1_)

      Specified by:
        `order` in class `io.netty.buffer.ByteBuf`

    - #### unwrap

          public io.netty.buffer.ByteBuf unwrap()

      Specified by:
        `unwrap` in class `io.netty.buffer.ByteBuf`

    - #### isDirect

          public boolean isDirect()

      Specified by:
        `isDirect` in class `io.netty.buffer.ByteBuf`

    - #### readerIndex

          public int readerIndex()

      Specified by:
        `readerIndex` in class `io.netty.buffer.ByteBuf`

    - #### readerIndex

          public io.netty.buffer.ByteBuf readerIndex(int p_readerIndex_1_)

      Specified by:
        `readerIndex` in class `io.netty.buffer.ByteBuf`

    - #### writerIndex

          public int writerIndex()

      Specified by:
        `writerIndex` in class `io.netty.buffer.ByteBuf`

    - #### writerIndex

          public io.netty.buffer.ByteBuf writerIndex(int p_writerIndex_1_)

      Specified by:
        `writerIndex` in class `io.netty.buffer.ByteBuf`

    - #### setIndex

          public io.netty.buffer.ByteBuf setIndex(int p_setIndex_1_,
                                         int p_setIndex_2_)

      Specified by:
        `setIndex` in class `io.netty.buffer.ByteBuf`

    - #### readableBytes

          public int readableBytes()

      Specified by:
        `readableBytes` in class `io.netty.buffer.ByteBuf`

    - #### writableBytes

          public int writableBytes()

      Specified by:
        `writableBytes` in class `io.netty.buffer.ByteBuf`

    - #### maxWritableBytes

          public int maxWritableBytes()

      Specified by:
        `maxWritableBytes` in class `io.netty.buffer.ByteBuf`

    - #### isReadable

          public boolean isReadable()

      Specified by:
        `isReadable` in class `io.netty.buffer.ByteBuf`

    - #### isReadable

          public boolean isReadable(int p_isReadable_1_)

      Specified by:
        `isReadable` in class `io.netty.buffer.ByteBuf`

    - #### isWritable

          public boolean isWritable()

      Specified by:
        `isWritable` in class `io.netty.buffer.ByteBuf`

    - #### isWritable

          public boolean isWritable(int p_isWritable_1_)

      Specified by:
        `isWritable` in class `io.netty.buffer.ByteBuf`

    - #### clear

          public io.netty.buffer.ByteBuf clear()

      Specified by:
        `clear` in class `io.netty.buffer.ByteBuf`

    - #### markReaderIndex

          public io.netty.buffer.ByteBuf markReaderIndex()

      Specified by:
        `markReaderIndex` in class `io.netty.buffer.ByteBuf`

    - #### resetReaderIndex

          public io.netty.buffer.ByteBuf resetReaderIndex()

      Specified by:
        `resetReaderIndex` in class `io.netty.buffer.ByteBuf`

    - #### markWriterIndex

          public io.netty.buffer.ByteBuf markWriterIndex()

      Specified by:
        `markWriterIndex` in class `io.netty.buffer.ByteBuf`

    - #### resetWriterIndex

          public io.netty.buffer.ByteBuf resetWriterIndex()

      Specified by:
        `resetWriterIndex` in class `io.netty.buffer.ByteBuf`

    - #### discardReadBytes

          public io.netty.buffer.ByteBuf discardReadBytes()

      Specified by:
        `discardReadBytes` in class `io.netty.buffer.ByteBuf`

    - #### discardSomeReadBytes

          public io.netty.buffer.ByteBuf discardSomeReadBytes()

      Specified by:
        `discardSomeReadBytes` in class `io.netty.buffer.ByteBuf`

    - #### ensureWritable

          public io.netty.buffer.ByteBuf ensureWritable(int p_ensureWritable_1_)

      Specified by:
        `ensureWritable` in class `io.netty.buffer.ByteBuf`

    - #### ensureWritable

          public int ensureWritable(int p_ensureWritable_1_,
                           boolean p_ensureWritable_2_)

      Specified by:
        `ensureWritable` in class `io.netty.buffer.ByteBuf`

    - #### getBoolean

          public boolean getBoolean(int p_getBoolean_1_)

      Specified by:
        `getBoolean` in class `io.netty.buffer.ByteBuf`

    - #### getByte

          public byte getByte(int p_getByte_1_)

      Specified by:
        `getByte` in class `io.netty.buffer.ByteBuf`

    - #### getUnsignedByte

          public short getUnsignedByte(int p_getUnsignedByte_1_)

      Specified by:
        `getUnsignedByte` in class `io.netty.buffer.ByteBuf`

    - #### getShort

          public short getShort(int p_getShort_1_)

      Specified by:
        `getShort` in class `io.netty.buffer.ByteBuf`

    - #### getUnsignedShort

          public int getUnsignedShort(int p_getUnsignedShort_1_)

      Specified by:
        `getUnsignedShort` in class `io.netty.buffer.ByteBuf`

    - #### getMedium

          public int getMedium(int p_getMedium_1_)

      Specified by:
        `getMedium` in class `io.netty.buffer.ByteBuf`

    - #### getUnsignedMedium

          public int getUnsignedMedium(int p_getUnsignedMedium_1_)

      Specified by:
        `getUnsignedMedium` in class `io.netty.buffer.ByteBuf`

    - #### getInt

          public int getInt(int p_getInt_1_)

      Specified by:
        `getInt` in class `io.netty.buffer.ByteBuf`

    - #### getUnsignedInt

          public long getUnsignedInt(int p_getUnsignedInt_1_)

      Specified by:
        `getUnsignedInt` in class `io.netty.buffer.ByteBuf`

    - #### getLong

          public long getLong(int p_getLong_1_)

      Specified by:
        `getLong` in class `io.netty.buffer.ByteBuf`

    - #### getChar

          public char getChar(int p_getChar_1_)

      Specified by:
        `getChar` in class `io.netty.buffer.ByteBuf`

    - #### getFloat

          public float getFloat(int p_getFloat_1_)

      Specified by:
        `getFloat` in class `io.netty.buffer.ByteBuf`

    - #### getDouble

          public double getDouble(int p_getDouble_1_)

      Specified by:
        `getDouble` in class `io.netty.buffer.ByteBuf`

    - #### getBytes

          public io.netty.buffer.ByteBuf getBytes(int p_getBytes_1_,
                                         io.netty.buffer.ByteBuf p_getBytes_2_)

      Specified by:
        `getBytes` in class `io.netty.buffer.ByteBuf`

    - #### getBytes

          public io.netty.buffer.ByteBuf getBytes(int p_getBytes_1_,
                                         io.netty.buffer.ByteBuf p_getBytes_2_,
                                         int p_getBytes_3_)

      Specified by:
        `getBytes` in class `io.netty.buffer.ByteBuf`

    - #### getBytes

          public io.netty.buffer.ByteBuf getBytes(int p_getBytes_1_,
                                         io.netty.buffer.ByteBuf p_getBytes_2_,
                                         int p_getBytes_3_,
                                         int p_getBytes_4_)

      Specified by:
        `getBytes` in class `io.netty.buffer.ByteBuf`

    - #### getBytes

          public io.netty.buffer.ByteBuf getBytes(int p_getBytes_1_,
                                         byte[] p_getBytes_2_)

      Specified by:
        `getBytes` in class `io.netty.buffer.ByteBuf`

    - #### getBytes

          public io.netty.buffer.ByteBuf getBytes(int p_getBytes_1_,
                                         byte[] p_getBytes_2_,
                                         int p_getBytes_3_,
                                         int p_getBytes_4_)

      Specified by:
        `getBytes` in class `io.netty.buffer.ByteBuf`

    - #### getBytes

          public io.netty.buffer.ByteBuf getBytes(int p_getBytes_1_,
                                         java.nio.ByteBuffer p_getBytes_2_)

      Specified by:
        `getBytes` in class `io.netty.buffer.ByteBuf`

    - #### getBytes

          public io.netty.buffer.ByteBuf getBytes(int p_getBytes_1_,
                                         java.io.OutputStream p_getBytes_2_,
                                         int p_getBytes_3_)
                                           throws java.io.IOException

      Specified by:
        `getBytes` in class `io.netty.buffer.ByteBuf`
      Throws:
        `java.io.IOException`

    - #### getBytes

          public int getBytes(int p_getBytes_1_,
                     java.nio.channels.GatheringByteChannel p_getBytes_2_,
                     int p_getBytes_3_)
                       throws java.io.IOException

      Specified by:
        `getBytes` in class `io.netty.buffer.ByteBuf`
      Throws:
        `java.io.IOException`

    - #### setBoolean

          public io.netty.buffer.ByteBuf setBoolean(int p_setBoolean_1_,
                                           boolean p_setBoolean_2_)

      Specified by:
        `setBoolean` in class `io.netty.buffer.ByteBuf`

    - #### setByte

          public io.netty.buffer.ByteBuf setByte(int p_setByte_1_,
                                        int p_setByte_2_)

      Specified by:
        `setByte` in class `io.netty.buffer.ByteBuf`

    - #### setShort

          public io.netty.buffer.ByteBuf setShort(int p_setShort_1_,
                                         int p_setShort_2_)

      Specified by:
        `setShort` in class `io.netty.buffer.ByteBuf`

    - #### setMedium

          public io.netty.buffer.ByteBuf setMedium(int p_setMedium_1_,
                                          int p_setMedium_2_)

      Specified by:
        `setMedium` in class `io.netty.buffer.ByteBuf`

    - #### setInt

          public io.netty.buffer.ByteBuf setInt(int p_setInt_1_,
                                       int p_setInt_2_)

      Specified by:
        `setInt` in class `io.netty.buffer.ByteBuf`

    - #### setLong

          public io.netty.buffer.ByteBuf setLong(int p_setLong_1_,
                                        long p_setLong_2_)

      Specified by:
        `setLong` in class `io.netty.buffer.ByteBuf`

    - #### setChar

          public io.netty.buffer.ByteBuf setChar(int p_setChar_1_,
                                        int p_setChar_2_)

      Specified by:
        `setChar` in class `io.netty.buffer.ByteBuf`

    - #### setFloat

          public io.netty.buffer.ByteBuf setFloat(int p_setFloat_1_,
                                         float p_setFloat_2_)

      Specified by:
        `setFloat` in class `io.netty.buffer.ByteBuf`

    - #### setDouble

          public io.netty.buffer.ByteBuf setDouble(int p_setDouble_1_,
                                          double p_setDouble_2_)

      Specified by:
        `setDouble` in class `io.netty.buffer.ByteBuf`

    - #### setBytes

          public io.netty.buffer.ByteBuf setBytes(int p_setBytes_1_,
                                         io.netty.buffer.ByteBuf p_setBytes_2_)

      Specified by:
        `setBytes` in class `io.netty.buffer.ByteBuf`

    - #### setBytes

          public io.netty.buffer.ByteBuf setBytes(int p_setBytes_1_,
                                         io.netty.buffer.ByteBuf p_setBytes_2_,
                                         int p_setBytes_3_)

      Specified by:
        `setBytes` in class `io.netty.buffer.ByteBuf`

    - #### setBytes

          public io.netty.buffer.ByteBuf setBytes(int p_setBytes_1_,
                                         io.netty.buffer.ByteBuf p_setBytes_2_,
                                         int p_setBytes_3_,
                                         int p_setBytes_4_)

      Specified by:
        `setBytes` in class `io.netty.buffer.ByteBuf`

    - #### setBytes

          public io.netty.buffer.ByteBuf setBytes(int p_setBytes_1_,
                                         byte[] p_setBytes_2_)

      Specified by:
        `setBytes` in class `io.netty.buffer.ByteBuf`

    - #### setBytes

          public io.netty.buffer.ByteBuf setBytes(int p_setBytes_1_,
                                         byte[] p_setBytes_2_,
                                         int p_setBytes_3_,
                                         int p_setBytes_4_)

      Specified by:
        `setBytes` in class `io.netty.buffer.ByteBuf`

    - #### setBytes

          public io.netty.buffer.ByteBuf setBytes(int p_setBytes_1_,
                                         java.nio.ByteBuffer p_setBytes_2_)

      Specified by:
        `setBytes` in class `io.netty.buffer.ByteBuf`

    - #### setBytes

          public int setBytes(int p_setBytes_1_,
                     java.io.InputStream p_setBytes_2_,
                     int p_setBytes_3_)
                       throws java.io.IOException

      Specified by:
        `setBytes` in class `io.netty.buffer.ByteBuf`
      Throws:
        `java.io.IOException`

    - #### setBytes

          public int setBytes(int p_setBytes_1_,
                     java.nio.channels.ScatteringByteChannel p_setBytes_2_,
                     int p_setBytes_3_)
                       throws java.io.IOException

      Specified by:
        `setBytes` in class `io.netty.buffer.ByteBuf`
      Throws:
        `java.io.IOException`

    - #### setZero

          public io.netty.buffer.ByteBuf setZero(int p_setZero_1_,
                                        int p_setZero_2_)

      Specified by:
        `setZero` in class `io.netty.buffer.ByteBuf`

    - #### readBoolean

          public boolean readBoolean()

      Specified by:
        `readBoolean` in class `io.netty.buffer.ByteBuf`

    - #### readByte

          public byte readByte()

      Specified by:
        `readByte` in class `io.netty.buffer.ByteBuf`

    - #### readUnsignedByte

          public short readUnsignedByte()

      Specified by:
        `readUnsignedByte` in class `io.netty.buffer.ByteBuf`

    - #### readShort

          public short readShort()

      Specified by:
        `readShort` in class `io.netty.buffer.ByteBuf`

    - #### readUnsignedShort

          public int readUnsignedShort()

      Specified by:
        `readUnsignedShort` in class `io.netty.buffer.ByteBuf`

    - #### readMedium

          public int readMedium()

      Specified by:
        `readMedium` in class `io.netty.buffer.ByteBuf`

    - #### readUnsignedMedium

          public int readUnsignedMedium()

      Specified by:
        `readUnsignedMedium` in class `io.netty.buffer.ByteBuf`

    - #### readInt

          public int readInt()

      Specified by:
        `readInt` in class `io.netty.buffer.ByteBuf`

    - #### readUnsignedInt

          public long readUnsignedInt()

      Specified by:
        `readUnsignedInt` in class `io.netty.buffer.ByteBuf`

    - #### readLong

          public long readLong()

      Specified by:
        `readLong` in class `io.netty.buffer.ByteBuf`

    - #### readChar

          public char readChar()

      Specified by:
        `readChar` in class `io.netty.buffer.ByteBuf`

    - #### readFloat

          public float readFloat()

      Specified by:
        `readFloat` in class `io.netty.buffer.ByteBuf`

    - #### readDouble

          public double readDouble()

      Specified by:
        `readDouble` in class `io.netty.buffer.ByteBuf`

    - #### readBytes

          public io.netty.buffer.ByteBuf readBytes(int p_readBytes_1_)

      Specified by:
        `readBytes` in class `io.netty.buffer.ByteBuf`

    - #### readSlice

          public io.netty.buffer.ByteBuf readSlice(int p_readSlice_1_)

      Specified by:
        `readSlice` in class `io.netty.buffer.ByteBuf`

    - #### readBytes

          public io.netty.buffer.ByteBuf readBytes(io.netty.buffer.ByteBuf p_readBytes_1_)

      Specified by:
        `readBytes` in class `io.netty.buffer.ByteBuf`

    - #### readBytes

          public io.netty.buffer.ByteBuf readBytes(io.netty.buffer.ByteBuf p_readBytes_1_,
                                          int p_readBytes_2_)

      Specified by:
        `readBytes` in class `io.netty.buffer.ByteBuf`

    - #### readBytes

          public io.netty.buffer.ByteBuf readBytes(io.netty.buffer.ByteBuf p_readBytes_1_,
                                          int p_readBytes_2_,
                                          int p_readBytes_3_)

      Specified by:
        `readBytes` in class `io.netty.buffer.ByteBuf`

    - #### readBytes

          public io.netty.buffer.ByteBuf readBytes(byte[] p_readBytes_1_)

      Specified by:
        `readBytes` in class `io.netty.buffer.ByteBuf`

    - #### readBytes

          public io.netty.buffer.ByteBuf readBytes(byte[] p_readBytes_1_,
                                          int p_readBytes_2_,
                                          int p_readBytes_3_)

      Specified by:
        `readBytes` in class `io.netty.buffer.ByteBuf`

    - #### readBytes

          public io.netty.buffer.ByteBuf readBytes(java.nio.ByteBuffer p_readBytes_1_)

      Specified by:
        `readBytes` in class `io.netty.buffer.ByteBuf`

    - #### readBytes

          public io.netty.buffer.ByteBuf readBytes(java.io.OutputStream p_readBytes_1_,
                                          int p_readBytes_2_)
                                            throws java.io.IOException

      Specified by:
        `readBytes` in class `io.netty.buffer.ByteBuf`
      Throws:
        `java.io.IOException`

    - #### readBytes

          public int readBytes(java.nio.channels.GatheringByteChannel p_readBytes_1_,
                      int p_readBytes_2_)
                        throws java.io.IOException

      Specified by:
        `readBytes` in class `io.netty.buffer.ByteBuf`
      Throws:
        `java.io.IOException`

    - #### skipBytes

          public io.netty.buffer.ByteBuf skipBytes(int p_skipBytes_1_)

      Specified by:
        `skipBytes` in class `io.netty.buffer.ByteBuf`

    - #### writeBoolean

          public io.netty.buffer.ByteBuf writeBoolean(boolean p_writeBoolean_1_)

      Specified by:
        `writeBoolean` in class `io.netty.buffer.ByteBuf`

    - #### writeByte

          public io.netty.buffer.ByteBuf writeByte(int p_writeByte_1_)

      Specified by:
        `writeByte` in class `io.netty.buffer.ByteBuf`

    - #### writeShort

          public io.netty.buffer.ByteBuf writeShort(int p_writeShort_1_)

      Specified by:
        `writeShort` in class `io.netty.buffer.ByteBuf`

    - #### writeMedium

          public io.netty.buffer.ByteBuf writeMedium(int p_writeMedium_1_)

      Specified by:
        `writeMedium` in class `io.netty.buffer.ByteBuf`

    - #### writeInt

          public io.netty.buffer.ByteBuf writeInt(int p_writeInt_1_)

      Specified by:
        `writeInt` in class `io.netty.buffer.ByteBuf`

    - #### writeLong

          public io.netty.buffer.ByteBuf writeLong(long p_writeLong_1_)

      Specified by:
        `writeLong` in class `io.netty.buffer.ByteBuf`

    - #### writeChar

          public io.netty.buffer.ByteBuf writeChar(int p_writeChar_1_)

      Specified by:
        `writeChar` in class `io.netty.buffer.ByteBuf`

    - #### writeFloat

          public io.netty.buffer.ByteBuf writeFloat(float p_writeFloat_1_)

      Specified by:
        `writeFloat` in class `io.netty.buffer.ByteBuf`

    - #### writeDouble

          public io.netty.buffer.ByteBuf writeDouble(double p_writeDouble_1_)

      Specified by:
        `writeDouble` in class `io.netty.buffer.ByteBuf`

    - #### writeBytes

          public io.netty.buffer.ByteBuf writeBytes(io.netty.buffer.ByteBuf p_writeBytes_1_)

      Specified by:
        `writeBytes` in class `io.netty.buffer.ByteBuf`

    - #### writeBytes

          public io.netty.buffer.ByteBuf writeBytes(io.netty.buffer.ByteBuf p_writeBytes_1_,
                                           int p_writeBytes_2_)

      Specified by:
        `writeBytes` in class `io.netty.buffer.ByteBuf`

    - #### writeBytes

          public io.netty.buffer.ByteBuf writeBytes(io.netty.buffer.ByteBuf p_writeBytes_1_,
                                           int p_writeBytes_2_,
                                           int p_writeBytes_3_)

      Specified by:
        `writeBytes` in class `io.netty.buffer.ByteBuf`

    - #### writeBytes

          public io.netty.buffer.ByteBuf writeBytes(byte[] p_writeBytes_1_)

      Specified by:
        `writeBytes` in class `io.netty.buffer.ByteBuf`

    - #### writeBytes

          public io.netty.buffer.ByteBuf writeBytes(byte[] p_writeBytes_1_,
                                           int p_writeBytes_2_,
                                           int p_writeBytes_3_)

      Specified by:
        `writeBytes` in class `io.netty.buffer.ByteBuf`

    - #### writeBytes

          public io.netty.buffer.ByteBuf writeBytes(java.nio.ByteBuffer p_writeBytes_1_)

      Specified by:
        `writeBytes` in class `io.netty.buffer.ByteBuf`

    - #### writeBytes

          public int writeBytes(java.io.InputStream p_writeBytes_1_,
                       int p_writeBytes_2_)
                         throws java.io.IOException

      Specified by:
        `writeBytes` in class `io.netty.buffer.ByteBuf`
      Throws:
        `java.io.IOException`

    - #### writeBytes

          public int writeBytes(java.nio.channels.ScatteringByteChannel p_writeBytes_1_,
                       int p_writeBytes_2_)
                         throws java.io.IOException

      Specified by:
        `writeBytes` in class `io.netty.buffer.ByteBuf`
      Throws:
        `java.io.IOException`

    - #### writeZero

          public io.netty.buffer.ByteBuf writeZero(int p_writeZero_1_)

      Specified by:
        `writeZero` in class `io.netty.buffer.ByteBuf`

    - #### indexOf

          public int indexOf(int p_indexOf_1_,
                    int p_indexOf_2_,
                    byte p_indexOf_3_)

      Specified by:
        `indexOf` in class `io.netty.buffer.ByteBuf`

    - #### bytesBefore

          public int bytesBefore(byte p_bytesBefore_1_)

      Specified by:
        `bytesBefore` in class `io.netty.buffer.ByteBuf`

    - #### bytesBefore

          public int bytesBefore(int p_bytesBefore_1_,
                        byte p_bytesBefore_2_)

      Specified by:
        `bytesBefore` in class `io.netty.buffer.ByteBuf`

    - #### bytesBefore

          public int bytesBefore(int p_bytesBefore_1_,
                        int p_bytesBefore_2_,
                        byte p_bytesBefore_3_)

      Specified by:
        `bytesBefore` in class `io.netty.buffer.ByteBuf`

    - #### forEachByte

          public int forEachByte(io.netty.buffer.ByteBufProcessor p_forEachByte_1_)

      Specified by:
        `forEachByte` in class `io.netty.buffer.ByteBuf`

    - #### forEachByte

          public int forEachByte(int p_forEachByte_1_,
                        int p_forEachByte_2_,
                        io.netty.buffer.ByteBufProcessor p_forEachByte_3_)

      Specified by:
        `forEachByte` in class `io.netty.buffer.ByteBuf`

    - #### forEachByteDesc

          public int forEachByteDesc(io.netty.buffer.ByteBufProcessor p_forEachByteDesc_1_)

      Specified by:
        `forEachByteDesc` in class `io.netty.buffer.ByteBuf`

    - #### forEachByteDesc

          public int forEachByteDesc(int p_forEachByteDesc_1_,
                            int p_forEachByteDesc_2_,
                            io.netty.buffer.ByteBufProcessor p_forEachByteDesc_3_)

      Specified by:
        `forEachByteDesc` in class `io.netty.buffer.ByteBuf`

    - #### copy

          public io.netty.buffer.ByteBuf copy()

      Specified by:
        `copy` in class `io.netty.buffer.ByteBuf`

    - #### copy

          public io.netty.buffer.ByteBuf copy(int p_copy_1_,
                                     int p_copy_2_)

      Specified by:
        `copy` in class `io.netty.buffer.ByteBuf`

    - #### slice

          public io.netty.buffer.ByteBuf slice()

      Specified by:
        `slice` in class `io.netty.buffer.ByteBuf`

    - #### slice

          public io.netty.buffer.ByteBuf slice(int p_slice_1_,
                                      int p_slice_2_)

      Specified by:
        `slice` in class `io.netty.buffer.ByteBuf`

    - #### duplicate

          public io.netty.buffer.ByteBuf duplicate()

      Specified by:
        `duplicate` in class `io.netty.buffer.ByteBuf`

    - #### nioBufferCount

          public int nioBufferCount()

      Specified by:
        `nioBufferCount` in class `io.netty.buffer.ByteBuf`

    - #### nioBuffer

          public java.nio.ByteBuffer nioBuffer()

      Specified by:
        `nioBuffer` in class `io.netty.buffer.ByteBuf`

    - #### nioBuffer

          public java.nio.ByteBuffer nioBuffer(int p_nioBuffer_1_,
                                      int p_nioBuffer_2_)

      Specified by:
        `nioBuffer` in class `io.netty.buffer.ByteBuf`

    - #### internalNioBuffer

          public java.nio.ByteBuffer internalNioBuffer(int p_internalNioBuffer_1_,
                                              int p_internalNioBuffer_2_)

      Specified by:
        `internalNioBuffer` in class `io.netty.buffer.ByteBuf`

    - #### nioBuffers

          public java.nio.ByteBuffer[] nioBuffers()

      Specified by:
        `nioBuffers` in class `io.netty.buffer.ByteBuf`

    - #### nioBuffers

          public java.nio.ByteBuffer[] nioBuffers(int p_nioBuffers_1_,
                                         int p_nioBuffers_2_)

      Specified by:
        `nioBuffers` in class `io.netty.buffer.ByteBuf`

    - #### hasArray

          public boolean hasArray()

      Specified by:
        `hasArray` in class `io.netty.buffer.ByteBuf`

    - #### array

          public byte[] array()

      Specified by:
        `array` in class `io.netty.buffer.ByteBuf`

    - #### arrayOffset

          public int arrayOffset()

      Specified by:
        `arrayOffset` in class `io.netty.buffer.ByteBuf`

    - #### hasMemoryAddress

          public boolean hasMemoryAddress()

      Specified by:
        `hasMemoryAddress` in class `io.netty.buffer.ByteBuf`

    - #### memoryAddress

          public long memoryAddress()

      Specified by:
        `memoryAddress` in class `io.netty.buffer.ByteBuf`

    - #### toString

          public java.lang.String toString(java.nio.charset.Charset p_toString_1_)

      Specified by:
        `toString` in class `io.netty.buffer.ByteBuf`

    - #### toString

          public java.lang.String toString(int p_toString_1_,
                                  int p_toString_2_,
                                  java.nio.charset.Charset p_toString_3_)

      Specified by:
        `toString` in class `io.netty.buffer.ByteBuf`

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in class `io.netty.buffer.ByteBuf`

    - #### equals

          public boolean equals(java.lang.Object par1Obj)

      Specified by:
        `equals` in class `io.netty.buffer.ByteBuf`

    - #### compareTo

          public int compareTo(io.netty.buffer.ByteBuf par1Obj)

      Specified by:
        `compareTo` in interface `java.lang.Comparable<io.netty.buffer.ByteBuf>`
      Specified by:
        `compareTo` in class `io.netty.buffer.ByteBuf`

    - #### toString

          public java.lang.String toString()

      Specified by:
        `toString` in class `io.netty.buffer.ByteBuf`

    - #### retain

          public io.netty.buffer.ByteBuf retain(int p_retain_1_)

      Specified by:
        `retain` in interface `io.netty.util.ReferenceCounted`
      Overrides:
        `retain` in class `io.netty.buffer.ByteBuf`

    - #### retain

          public io.netty.buffer.ByteBuf retain()

      Specified by:
        `retain` in interface `io.netty.util.ReferenceCounted`
      Overrides:
        `retain` in class `io.netty.buffer.ByteBuf`

    - #### refCnt

          public int refCnt()

    - #### release

          public boolean release()

    - #### release

          public boolean release(int p_release_1_)